/*
 * Copyright (c) 2008 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE file for licencing information.
 *
 * Created on Jan 11, 2009
 * Author: K. Benedyczak <golbi@mat.umk.pl>
 */

package pl.edu.icm.unicore.uvos.registration;

import eu.unicore.security.util.client.IClientProperties;
import eu.unicore.security.util.client.SimpleClientPropertiesImpl;
import pl.edu.icm.unicore.uvos.util.ConfDefaults;
import pl.edu.icm.unicore.uvos.util.Configuration;

public class ClientSecurityConfiguration extends SimpleClientPropertiesImpl implements Cloneable
{
	private Configuration conf;
	
	public ClientSecurityConfiguration(Configuration conf)
	{
		this.conf = conf;
	}
	
	@Override
	public String getKeystore()
	{
		return conf.getAsString(ConfDefaults.KEYSTORE,
			ConfDefaults.keystore, null);
	}

	@Override
	public String getKeystoreAlias()
	{
		return conf.getAsString(ConfDefaults.KEYSTORE_ALIAS,
			ConfDefaults.keystoreAlias, null);
	}
	@Override
	public String getKeystoreKeyPassword()
	{
		String ksPasswd = conf.getAsString(ConfDefaults.KEYSTORE_PASSWD, 
			ConfDefaults.keystorePasswd, null); 
		return conf.getAsString(ConfDefaults.KEYSTORE_KEY_PASSWD, 
				ksPasswd, null, false);
	}
	@Override
	public String getKeystorePassword()
	{
		return conf.getAsString(ConfDefaults.KEYSTORE_PASSWD, 
			ConfDefaults.keystorePasswd, null);
	}
	@Override
	public String getKeystoreType()
	{
		return conf.getAsString(ConfDefaults.KEYSTORE_TYPE,
			ConfDefaults.keystoreType, null);
	}
	@Override
	public String getTruststore()
	{
		return conf.getAsString(ConfDefaults.TRUSTSTORE,
			ConfDefaults.truststore, null);
	}
	@Override
	public String getTruststorePassword()
	{
		return conf.getAsString(ConfDefaults.TRUSTSTORE_PASSWD, 
			ConfDefaults.truststorePasswd, null);
	}
	@Override
	public String getTruststoreType()
	{
		return conf.getAsString(ConfDefaults.TRUSTSTORE_TYPE,
			ConfDefaults.truststoreType, null);
	}
	@Override
	public boolean doSSLAuthn()
	{
		return true;
	}
	@Override
	public IClientProperties clone()
	{
		return new ClientSecurityConfiguration(conf);
	}

	@Override
	public boolean isSslEnabled()
	{
		return true;
	}
}
