/*
 * Copyright (c) 2007, 2008 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE file for licencing information.
 *
 * Created on Aug 26, 2007
 * Author: K. Benedyczak <golbi@mat.umk.pl>
 */

package pl.edu.icm.unicore.uvos.server;

import java.security.PrivateKey;
import java.security.cert.X509Certificate;

/**
 * Interface returning data needed for setting issuer identity, veryfing signatures
 * and signing assertions/protocol messages.
 * @author K. Benedyczak
 */
public interface CryptoDataProvider
{
	public X509Certificate getServerCertificate();
	public X509Certificate[] getServerCertificateC();
	public PrivateKey getPrivateKey();
	public String getIssuerURI();
}
